require "world"
require "player"

function love.load()
	add_block(50,50,50,400)
	add_block(50,450,700,50)
	add_block(700,50,50,400)
	add_block(350,400,100,50)

	screen = {}
	screen.w = love.window.getWidth()
	screen.h = love.window.getHeight()

	cam = {}
	cam.x = 0
	cam.y = 0
	cam.tx = 0
	cam.ty = 0

	cam.speed = 3
end

function love.update(dt)
	player_update(dt)
	world_update(dt)

	cam.tx = -(player.x + player.xvel) + screen.w/2
	cam.ty = -player.y + -player.yvel/2 + screen.h/2

	cam.x = cam.x + ((cam.tx - cam.x) * cam.speed * dt)
	cam.y = cam.y + ((cam.ty - cam.y) * cam.speed * dt)	
end

function love.draw()
	love.graphics.push()
	love.graphics.translate(cam.x,cam.y)
	world_draw()
	player_draw()
	love.graphics.pop()

	love.graphics.print(love.timer.getFPS(),10,10)
end

function love.mousepressed(x,y,button)

end

function love.mousereleased(x,y,button)
	if(button == "r") then
		for i,v in ipairs(blocks) do
			if(CheckCollision(x - cam.x,y - cam.y,1,1,v.x,v.y,v.w,v.h)) then
				table.remove(blocks,i)
			end
		end
	end
	if(button == "l") then
		if(addW < 0) then
			addX = addX + addW
			addW = -addW
		end

		if(addH < 0) then
			addY = addY + addH
			addH = -addH
		end

		if(addW ~= 0 and addH ~= 0) then
			add_block(addX,addY,addW,addH)
		end

		addX = 0
		addY = 0
	end
end


function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end