blocks = {}

addX = 0
addY = 0
addW = 0
addH = 0

gridS = 25
function world_update(dt)
	if(love.mouse.isDown("l")) then
		if(addX == 0) then
			addX = math.floor((love.mouse.getX() + gridS/2 - cam.x)/gridS) * gridS
			addY = math.floor((love.mouse.getY() + gridS/2 - cam.y)/gridS) * gridS
		end
		
		addW = math.floor((love.mouse.getX() + gridS/2 - addX - cam.x)/gridS) * gridS
		addH = math.floor((love.mouse.getY() + gridS/2 - addY - cam.y)/ gridS) * gridS
	end
end

function world_draw()
	--grid
	love.graphics.setColor(50,50,50,200)
	for i=1,screen.w/gridS + 1 do
		local x = math.floor((-cam.x)/gridS)*gridS + i * gridS
		local gy = math.floor((-cam.y)/gridS)*gridS
		love.graphics.line(x,gy,x,gy+screen.h)
		local y = math.floor((-cam.y)/gridS)*gridS + i * gridS
		local gx = math.floor((-cam.x)/gridS)*gridS
		love.graphics.line(gx,y,gx + screen.w,y)
	end
	love.graphics.setColor(255,255,255)


	if(love.mouse.isDown("l")) then
		love.graphics.circle("line",addX,addY,10)
		love.graphics.circle("line",addX + addW,addY + addH,10)
		love.graphics.rectangle("line",addX,addY,addW,addH)
	end
	for i,v in ipairs(blocks) do
		love.graphics.rectangle("line",v.x,v.y,v.w,v.h)
	end
end

function block_col(x,y,w,h,grounded,dx,dy,dt)
	local onland = false
	for i,v in ipairs(blocks) do
		if(x + w/2 > v.x and x - w/2 < v.x + v.w) then
			if(y - h/2 > v.y + v.h and y - h/2 + dy * dt < v.y + v.h) then
				y = v.y + v.h + h/2
				dy = 0
			end
			if(y + h/2 < v.y and y + h/2 + dy * dt > v.y) then
				y = v.y - h/2
				dy = 0
				grounded = true
			end
		end
		
		if(y + h/2 > v.y and y - h/2 < v.y + v.h) then
			if(x + w/2 < v.x and x + w/2 + dx * dt > v.x or (dx > 1 and x + w/2 == v.x)) then
				x = v.x - w/2
				dx = 0
			end
			if(x - w/2 > v.x + v.w and x - w/2 + dx * dt < v.x + v.w or (x - w/2 == v.x + v.w and dx < 0)) then
				x = v.x + v.w + w/2
				dx = 0
			end
		end
		
		if(grounded == true and y + h/2 == v.y and x + w/2 > v.x and x - w/2 < v.x + v.w) then
			onland = true
		end
	end
	if(onland == true) then
		grounded = true
	else
		grounded = false
	end
	
	return x,y,dx,dy,grounded
end

function add_block(x,y,w,h)
	local bl = {}
	bl.x = x
	bl.y = y
	bl.w = w
	bl.h = h
	
	table.insert(blocks,bl)
end